"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClassProperty = exports.createFunctionProperty = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const createEntriesArray = props => {
  const entries = _lodash.default.uniq(props).sort().map(prop => t.stringLiteral(prop));

  return t.arrayExpression(entries);
};

const createFunctionProperty = (identifier, props) => {
  const left = t.memberExpression(t.identifier(identifier), t.identifier('handledProps'));
  const right = createEntriesArray(props);
  return t.expressionStatement(t.assignmentExpression('=', left, right));
};

exports.createFunctionProperty = createFunctionProperty;

const createClassProperty = props => {
  const key = t.identifier('handledProps');
  const value = createEntriesArray(props);
  const property = t.classProperty(key, value);
  property.static = true;
  return property;
};

exports.createClassProperty = createClassProperty;