"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.UnnamedClass = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

var _getVariableDeclarator = _interopRequireDefault(require("./getVariableDeclarator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const getPositionIdentifier = ({
  node
}) => _lodash.default.get(node, 'id.name');

const UnnamedClass = '___UnnamedClass___';
exports.UnnamedClass = UnnamedClass;

const getFunctionIdentifier = path => {
  if (t.isFunctionDeclaration(path)) return getPositionIdentifier(path);

  if (t.isArrowFunctionExpression(path) || t.isFunctionExpression(path)) {
    return getPositionIdentifier((0, _getVariableDeclarator.default)(path));
  }

  throw path.buildCodeFrameError('`path` is unsupported Function definition');
};

const getEntryIdentifier = path => {
  if (t.isClass(path)) {
    return getPositionIdentifier(path) || UnnamedClass;
  }

  if (t.isFunction(path)) {
    return getFunctionIdentifier(path);
  }

  throw path.buildCodeFrameError('`path` must be Class or Function definition');
};

var _default = getEntryIdentifier;
exports.default = _default;