"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isValidProperty = exports.isValidExpression = exports.isStaticProperty = exports.isObjectValue = exports.isObjectProperty = exports.isArrayValue = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const isArrayValue = path => t.isArrayExpression(path);

exports.isArrayValue = isArrayValue;

const isObjectProperty = path => t.isObjectProperty(path);

exports.isObjectProperty = isObjectProperty;

const isObjectValue = path => t.isObjectExpression(path);

exports.isObjectValue = isObjectValue;

const isStaticProperty = ({
  node
}) => !!node.static;

exports.isStaticProperty = isStaticProperty;

const isValidExpression = ({
  node: {
    left = {}
  }
}, names) => {
  const {
    property
  } = left;
  const {
    name
  } = property;
  return t.isMemberExpression(left) && t.isIdentifier(property) && _lodash.default.includes(names, name);
};

exports.isValidExpression = isValidExpression;

const isValidProperty = (path, names) => {
  const {
    node: {
      key
    }
  } = path;
  const {
    name
  } = key;
  return t.isIdentifier(key) && _lodash.default.includes(names, name);
};

exports.isValidProperty = isValidProperty;